.TH qmail-bfrmt 8 "" openqmail
.SH NAME
qmail-bfrmt \- run program(s) before invoking
.B qmail-remote
.SH SYNOPSIS
.B qmail-bfrmt
.SH DESCRIPTION
.B qmail-bfrmt
plugs into the pipe 
.B qmail-rspawn
\->
.B qmail-remote.
It reads a series of remote delivery commands from 
.B qmail-rspawn.
Then it reads command(s) from its config file
.IR "QMAILHOME/control/beforemote"
, before
.B qmail-remote
will be invoked.
.B qmail-remote
have to be the last program in the pipe and can be called one time only.
Make sure that the pipeline will not be broken.
.B qmail-bfrmt
writes to system log (default).
.SH ENVIRONMENT VARIABLES
.TR 
.IR $BINDIR
holds the value
.IR QMAILHOME/bin.
It will be set by
.B qmail-bfrmt
and can be used in the config file.
.SH CONFIG FILE
.B qmail-bfrmt
reads one or more commands from
.IR QMAILHOME/control/beforemote.
If the config file doesn't exists or an error occures
.B qmail-bfrmt 
ignores this silently and executes 
.B qmail-remote
directly.
.SH EXAMPLE
Edit
.IR QMAILHOME/control/beforemote
and add some commands:

   #!/bin/sh

   printenv > /tmp/envars
   printf "$1\\n$2\\n$3\\n" > /tmp/params
   export DKREMOTE="$BINDIR/qmail-remote"
   if ["$DKREMOTE" ] ; then
      $DKREMOTE "$@"
    else
      np="qmail-remote" ; exec $np "$@"
   fi

The first line '#!/bin/sh' has no effect, it is for syntax highlighting only.
.SH "SEE ALSO"
qmail-send(8),
qmail-remote(8),
qmail-rspawn(8)
